#!/usr/bin/python3
print('*** Šum 1/f polprevodnikov - S53MV 8.2.2021 ***')

import math
fmin=1e0    #začetni f
fmax=1e9    #končni f
fcb=3e3     #bulk
fb0=2
fcs=3e6     #surface
fs0=1.4

f=fmin
kf=1.1
dd=[]
lb=[]
ls=[]
while f<=fmax:
    dd+=[f]
    lb+=[10*math.log10(fb0*(1+fcb/f))]
    ls+=[10*math.log10(fs0*(1+fcs/f))] 
    f*=kf

import matplotlib.pyplot as plt
fig=plt.figure()
plt.semilogx(dd,ls,'r--')
plt.semilogx(dd,lb,'b')
plt.axis([fmin,fmax,0,60])
plt.xticks([1,30,1e3,3e4,1e6,3e7,1e9],['1Hz','30Hz','1kHz','30kHz','1MHz','30MHz','1GHz'])
plt.xlabel('Frequency $\Delta f$ [Hz]')
plt.ylabel('Noise figure $F\'$ [dB]')
plt.grid(c='k',linestyle='--')
fig.savefig('device.svg', transparent=True)
plt.show()

print('*** Konec ***')
