#!/usr/bin/python3
print('*** Rešitev Lorentzove črte - S53MV 7.2.2021 ***')

import math
dfmin=1e0   #začetni deltaf
dfmax=1e9   #končni deltaf
kb=1.38e-23 #Boltzmann
t0=290      #sobna temperatura
f0=3e9      #osrednja frekvenca
ql=10       #obremenjena kvaliteta
p0=1e-4     #moc oscilatorja
ff=10       #sumno stevilo

fhw=math.pi*kb*t0*ff/8/p0*(f0/ql)**2    #polovična širina Lorentzove črte

df=dfmin
kdf=1.1
dd=[]
ll=[]
lz=[]
mm=[]
while df<=dfmax:
    dd+=[df]
    ll+=[10*math.log10(0.5*(1+(f0/2/ql/df)**2)*kb*t0*ff/p0)]    #Leeson
    lz+=[10*math.log10(fhw/math.pi/(fhw**2+df**2))]             #Lorentz
    mm+=[10*math.log10(1/df)]
    df*=kdf

import matplotlib.pyplot as plt
fig=plt.figure()
plt.semilogx(dd,mm,'r--')
plt.semilogx(dd,ll,'c--')
plt.semilogx(dd,lz,'b')
plt.axis([dfmin,dfmax,-160,0])
plt.xticks([1,30,1e3,3e4,1e6,3e7,1e9],['1Hz','30Hz','1kHz','30kHz','1MHz','30MHz','1GHz'])
plt.xlabel('Offset from carrier $\Delta f$ [Hz]')
plt.ylabel('Relative phase-noise spectral density $L(\Delta f)$ [dBc/Hz]')
plt.grid(c='k',linestyle='--')
fig.savefig('lorentz.svg', transparent=True)
plt.show()

print('*** Konec ***')
