#!/usr/bin/python3
print('*** Spekter faznega šuma - S53MV 8.2.2021 ***')

import math
fmin=2.5e9  #začetni f
fmax=3.5e9  #končni f
kb=1.38e-23 #Boltzmann
t0=290      #sobna temperatura
f0=3e9      #osrednja frekvenca
ql=10       #obremenjena kvaliteta
p0=1e-4     #moc oscilatorja
ff=10       #sumno stevilo

fhw=math.pi*kb*t0*ff/8/p0*(f0/ql)**2    #polovična širina Lorentzove črte

f=fmin
kf=1e6
dd=[]
ll=[]
while f<=fmax:
    dd+=[f]
    df=f-f0
    if abs(df)>kf/2:
        ll+=[10*math.log10(0.5*(1+(f0/2/ql/df)**2)*kb*t0*ff/p0)]    #Leeson
    else:
        ll+=[0]
    f+=kf

import matplotlib.pyplot as plt
fig=plt.figure()
plt.plot(dd,ll,'b')
plt.axis([fmin,fmax,-160,0])
plt.xticks([2.6e9,2.8e9,3e9,3.2e9,3.4e9],['2.6GHz','2.8GHz','3.0GHz','3.2GHz','3.4GHz'])
plt.xlabel('Frequency $f$ [Hz]')
plt.ylabel('Relative phase-noise spectral density $L(\Delta f)$ [dBc/Hz]')
plt.grid(c='k',linestyle='--')
fig.savefig('spectrum.svg', transparent=True)
plt.show()

print('*** Konec ***')
